Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::TwoZero Class Reference

STK two-zero filter class. More...

`#include <TwoZero.h>`

Inheritance diagram for stk::TwoZero:

List of all members.

## Public Member Functions
| TwoZero ()
| Default constructor creates a second-order pass-through filter.
| ~TwoZero ()
| Class destructor.
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setB1 (StkFloat b1)
| Set the b[1] coefficient value.
void | setB2 (StkFloat b2)
| Set the b[2] coefficient value.
void | setCoefficients (StkFloat b0, StkFloat b1, StkFloat b2, bool clearState=false)
| Set all filter coefficients.
void | setNotch (StkFloat frequency, StkFloat radius)
| Sets the filter coefficients for a "notch" at frequency (in Hz).
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK two-zero filter class.

This class implements a two-zero digital filter. A method is provided for creating a "notch" in the frequency response while maintaining a constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995 - 2010.

## Member Function Documentation

void stk::TwoZero::setNotch | ( | StkFloat | frequency,
|  | StkFloat | radius |
| ) |  |  |

Sets the filter coefficients for a "notch" at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate zeros with the given frequency (in Hz) and radius from the z-plane origin. The coefficients are then normalized to produce a maximum filter gain of one (independent of the filter gain parameter). The resulting filter frequency response has a "notch" or anti-resonance at the given frequency. The closer the zeros are to the unit-circle (radius close to or equal to one), the narrower the resulting notch width.

StkFrames & stk::TwoZero::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

StkFrames & stk::TwoZero::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

The documentation for this class was generated from the following file:

- TwoZero.h

The Synthesis ToolKit in C++ (STK)
©1995-2010 Perry R. Cook and Gary P. Scavone. All Rights Reserved.